#ifndef DATA_H
#define DATA_H
#include "message.h"

struct LogFiles {
 LogFiles *next;
 LogFiles *prev;
 char *filename;
 bool processed;
};
	
// Ein Message Container
struct MContainer {
  Message *message;
  MContainer *next;
};

// Die localen Domains
struct LDomains {
  char *unixuser;
  char *domain;
  LDomains *next;
};

// Die Mitglieder einer Domain
struct Members {
  char *name;			// name + domainname = email adresse
  Message *messages;		// die nachrichten dieses users
  unsigned long anzahlm;
  unsigned long incoming;
  unsigned long outgoing;
  unsigned long incbytes;
  unsigned long outbytes;
  unsigned long local;
  unsigned long localbytes;
  unsigned long anzahld;// Gesamtanzahl der Deliveries
  unsigned long bytes;  // Gesamtanzahl der bytes
  struct tm *start;	// Die erste registrierte Nachricht
  struct tm *end;	// Die letzte registreirte Nachricht
  unsigned long sec;	// sekunden zw. erster und letzter Nachricht
  Members *next;
};

// Die Ergebnisse jeder Domain
struct Domains {
  char *domainname;
  char *filename;
  char *link;
  MContainer *messages;    // Nachrichten die bereits abgeschlossen sind
  MContainer *lmessage;	// Letzte NAchricht -> speed
  unsigned long anzahlm;// Gesamtanzahl der Nachrichten
  unsigned long incoming;
  unsigned long outgoing;
  double incbytes;
  double outbytes;
  unsigned long local;
  double localbytes;
  unsigned long anzahld;// Gesamtanzahl der Deliveries
  double bytes;  // Gesamtanzahl der bytes
  struct tm *start;	// Die erste registrierte Nachricht
  struct tm *end;	// Die letzte registreirte Nachricht
  unsigned long sec;	// sekunden zw. erster und letzter Nachricht
  bool islocal;
  Members *members;
  Domains *next;
  int relyear;	// ab 1900
  unsigned long monthusage[12];
  unsigned long monthbytes[12];
};

#endif
